package com.lsw.controller;

import com.jfinal.core.Controller;
import com.jfinal.kit.JsonKit;
import com.jfinal.kit.Kv;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;
import com.lsw.utils.StringUtil;
import com.lsw.utils.TimeUtil;

import java.util.List;
import java.util.stream.Collectors;

public class ReportController extends Controller {

    public void index() {
        String op = getPara("op", "finish");
        String ID = getPara("ID", "__HZPWsyc0ZOqvua4Lwwg");//部门ID
        set("begin", TimeUtil.getDay("firstDay"));
        set("end", TimeUtil.getDay("lastDay"));
        set("DOMAINID", getPara("DOMAINID", "uumsxrgm1KEEqSZIoHs"));
        set("ID", ID);
        List<Record> department_list = Db.template("department", Kv.by("ID", ID)).find();
        List<Record> list = department_list.stream().filter(r -> r.get("ID").equals(ID)).collect(Collectors.toList());
        for (Record record : list) {
            //二级
            List<Record> list2 = department_list.stream().filter(r -> r.get("SUPERIOR")!=null&&r.get("SUPERIOR").equals(record.get("ID"))).collect(Collectors.toList());
            record.set("children", list2);
            for (Record record2 : list2) {
                //三级
                List<Record> list3 = department_list.stream().filter(r ->r.get("SUPERIOR")!=null&&r.get("SUPERIOR").equals(record2.get("ID"))).collect(Collectors.toList());
                record2.set("children", list3);
            }

        }

        System.out.println("asd：" + JsonKit.toJson(list));
        set("department",JsonKit.toJson(list));
        render(op + ".html");
    }

    public void getData() {
        long start = System.currentTimeMillis();
        Kv kv = Kv.create();
        kv.set("DOMAINID", getPara("DOMAINID"));
        kv.set("ID", getPara("ID"));
        kv.set("begin", getPara("begin", TimeUtil.getDay("firstDay")));
        kv.set("end", getPara("end", TimeUtil.getDay("lastDay")));
        List<Record> list = Db.template("finish", kv).find();
        long end = System.currentTimeMillis();
        renderJson(Kv.by("data", list).set("time", StringUtil.mul((end - start), (float) 0.001) + "s"));
    }
}